
  use master
  go
  drop database ooexample
  go
  create database ooexample on default=8 log on default=8
  go
  sp_dboption ooexample, 'trunc. log on chkpt.', true
  go
  use ooexample
  go


exec sp_addtype 'tmsobjname', 'varchar(32)',  'NULL'
go

 create table class (
    id                    int           identity    primary key,
    name                  tmsobjname      not null,
--  check (name<>""),
    parent                int           null
-- references  class
 )
go

 create table method (
    class                 int           not null,
--    references  class,
    name                  tmsobjname      not null,
--    check (name<>""),
    type                  int           not null,
--    unique (class, name)
 )
go
 create table assignable (
    id                    int           not null,
--    references class,
    as_id                 int           not null
--    references class
 )
go

-- -------------------------------------------------------
create procedure registerclass
  @name       tmsobjname,
  @parentname tmsobjname
as
  declare @id int
  declare @parentid int

  create table #registerclass(id int, as_id int, already_exists int)

  select  @parentid=id from class where name=@parentname
  if @parentid is null
    raiserror ('Parent class is uncnown!',16,-1)

  if exists (select id from class where name=@name and parent=@parentid)
    raiserror ('Class already exists!',16,-1)

  insert into class(name, parent) values (@name, @parentid)
  select @id=@@identity

  insert into #registerclass
    select @id, as_id, 0 from assignable
      where id=@parentid

  insert into #registerclass values(@id, @id, 0)

  update #registerclass
    set already_exists=
      ( select count(*) from assignable
        where #registerclass.id=assignable.id
        and   #registerclass.as_id=assignable.as_id
      )

  insert into assignable
    select id, as_id from #registerclass
    where already_exists=0
go

-- -------------------------------------------------------
create procedure registermethod
  @classname      tmsobjname,
  @methodname     tmsobjname,
  @type           int
as
  declare @classid int

  select @classid=id from class where name=@classname

  if @classid is null
    raiserror ('Class is uncnown!',16,-1)

  if exists (select * from method where class=@classid and name=@methodname)
    raiserror ('Method already exists!',16,-1)

  insert into method(class, name, type) values (@classid, @methodname, @type)
go



 create table root (
    id                    int           identity    primary key,
    class                 int           not null,
--    references class,
    parent                int           null
--        references root
-- parent entity for version control
 )
go

declare @id int

insert into class (name, parent)
  values ('root', null)

select @id=@@identity

insert into assignable(id, as_id) values (@id, @id)

go

exec registermethod "root", "del", 2
go
create procedure root$$del
  @id int
as
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @classname tmsobjname
  select  @classname="unit"
  delete from root where id=@id
go

create procedure root$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id
    and class.id=root.class
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname
    and method.class=class.id
    and method.name="del"
  if @proc is not null
    begin
      exec @proc @id=@id
    end else begin
      select @errormsg=
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end
go

create procedure root$dup
  @id int,
  @parent int,
  @duplicate int output
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id
    and class.id=root.class
  select @proc=class.name+"$$dup" from class, method
    where class.name=@classname
    and method.class=class.id
    and method.name="dup"
  if @proc is not null
    begin
      exec @proc @id=@id, @parent=@parent, @duplicate=@duplicate output
    end else begin
      select @errormsg=
        "Method dup of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end
go


exec sp_addtype tmoney, "numeric(14,3)", "null"
go
exec sp_addtype tamount, "numeric(14,3)", "null"
go
exec sp_addtype tunitname, "varchar(10)", "null"
go
exec sp_addtype tcurrencyname, "varchar(10)", "null"
go
exec sp_addtype tresourcename, "varchar(20)", "null"
go
exec sp_addtype tworkname, "varchar(20)", "null"
go
exec sp_addtype teventname, "varchar(20)", "null"
go
exec registerclass "unit", "root"
go
create table unit (
id int not null,
name tunitname not null unique

)
go
create view unit$vi as
  select  root.id, class_name=class.name,
          unit.name
  from    root, class,
          unit
  where   root.class=class.id
    and   unit.id=root.id
go

create view unit$vxi as
  select  root.id, class_name=class.name,
          unit.name
  from    root, class,
          unit
  where   root.class=class.id
    and   unit.id=root.id
go

create view unit$v as
  select  root.id, class_name=class.name,
          unit.name
  from    root, class,
          unit
  where   root.class=class.id    and   class.name="unit"
    and   unit.id=root.id
go

create view unit$vx as
  select  root.id, class_name=class.name,
          unit.name
  from    root, class,
          unit
  where   root.class=class.id    and   class.name="unit"
    and   unit.id=root.id
go

exec registermethod "unit", "ins", 4
go
create procedure unit$ins
  @id int output,
  @name tunitname
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="ins"
  declare @procclassname tmsobjname
  select  @procclassname="unit"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
  declare @class int
  select @class=id from class where name="unit"
  insert into root(class, parent) values(@class, null)
  select @id=@@identity
  insert into unit (id, name)
    values (@id, @name)

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "unit", "upd", 1
go
create procedure unit$upd
  @id int,
  @name tunitname
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="upd"
  declare @procclassname tmsobjname
  select  @procclassname="unit"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  update unit
    set 
       name = @name
    where id=@id

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "unit", "del", 2
go
create procedure unit$$del
  @id int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @procclassname tmsobjname
  select  @procclassname="unit"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  delete from unit where id=@id
  delete from root where id=@id
return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure unit$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="del"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id    end else begin                                       
      select @errormsg=                             
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registerclass "currency", "root"
go
create table currency (
id int not null,
name tcurrencyname not null unique

)
go
create view currency$vi as
  select  root.id, class_name=class.name,
          currency.name
  from    root, class,
          currency
  where   root.class=class.id
    and   currency.id=root.id
go

create view currency$vxi as
  select  root.id, class_name=class.name,
          currency.name
  from    root, class,
          currency
  where   root.class=class.id
    and   currency.id=root.id
go

create view currency$v as
  select  root.id, class_name=class.name,
          currency.name
  from    root, class,
          currency
  where   root.class=class.id    and   class.name="currency"
    and   currency.id=root.id
go

create view currency$vx as
  select  root.id, class_name=class.name,
          currency.name
  from    root, class,
          currency
  where   root.class=class.id    and   class.name="currency"
    and   currency.id=root.id
go

exec registermethod "currency", "ins", 4
go
create procedure currency$ins
  @id int output,
  @name tcurrencyname
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="ins"
  declare @procclassname tmsobjname
  select  @procclassname="currency"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
  declare @class int
  select @class=id from class where name="currency"
  insert into root(class, parent) values(@class, null)
  select @id=@@identity
  insert into currency (id, name)
    values (@id, @name)

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "currency", "upd", 1
go
create procedure currency$upd
  @id int,
  @name tcurrencyname
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="upd"
  declare @procclassname tmsobjname
  select  @procclassname="currency"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  update currency
    set 
       name = @name
    where id=@id

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "currency", "del", 2
go
create procedure currency$$del
  @id int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @procclassname tmsobjname
  select  @procclassname="currency"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  delete from currency where id=@id
  delete from root where id=@id
return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure currency$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="del"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id    end else begin                                       
      select @errormsg=                             
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registerclass "cource", "root"
go
create table cource (
id int not null,
currency int not null,
date datetime not null default ( GETDATE() ),
rate tmoney not null
, unique (date,currency)

)
go
create index cource$dc on cource(date,currency)
go
create index cource$idx_u0000000b on cource(currency)
go
create trigger cource$ti on cource
for insert
as
  declare @errormsg varchar(255)
  -- trigger $diur$u00000008
  if update(currency)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.currency is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.currency
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   

  -- trigger $assign$u00000007
  declare @u00000006 int
  select  @u00000006=id from class where name="currency"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.currency
      and not exists (                       
        select id from assignable            
          where as_id=@u00000006           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types currency and @errormsg are not compatible"
      goto errorex
    end                                      

  return
errorex:
  raiserror 50000 @errormsg
go
create trigger cource$tu on cource
for update
as
  declare @errormsg varchar(255)
  -- trigger $diur$u00000008
  if update(currency)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.currency is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.currency
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   

  -- trigger $assign$u00000007
  declare @u00000006 int
  select  @u00000006=id from class where name="currency"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.currency
      and not exists (                       
        select id from assignable            
          where as_id=@u00000006           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types currency and @errormsg are not compatible"
      goto errorex
    end                                      

  return
errorex:
  raiserror 50000 @errormsg
go
create view cource$vi as
  select  root.id, class_name=class.name,
          cource.currency,
          cource.date,
          cource.rate
  from    root, class,
          cource
  where   root.class=class.id
    and   cource.id=root.id
go

create view cource$vxi as
  select  root.id, class_name=class.name,
          cource.currency,
          currency_name=u0000000c.name,
          cource.date,
          cource.rate
  from    root, class,
          cource,
          currency u0000000c
  where   root.class=class.id
    and   cource.id=root.id
    and   u0000000c.id=cource.currency
go

create view cource$v as
  select  root.id, class_name=class.name,
          cource.currency,
          cource.date,
          cource.rate
  from    root, class,
          cource
  where   root.class=class.id    and   class.name="cource"
    and   cource.id=root.id
go

create view cource$vx as
  select  root.id, class_name=class.name,
          cource.currency,
          currency_name=u0000000d.name,
          cource.date,
          cource.rate
  from    root, class,
          cource,
          currency u0000000d
  where   root.class=class.id    and   class.name="cource"
    and   cource.id=root.id
    and   u0000000d.id=cource.currency
go

exec registermethod "cource", "ins", 4
go
create procedure cource$ins
  @id int output,
  @currency int,
  @rate tmoney
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="ins"
  declare @procclassname tmsobjname
  select  @procclassname="cource"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
  declare @class int
  select @class=id from class where name="cource"
  insert into root(class, parent) values(@class, null)
  select @id=@@identity
  insert into cource (id, currency, rate)
    values (@id, @currency, @rate)

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "cource", "upd", 1
go
create procedure cource$upd
  @id int,
  @currency int,
  @rate tmoney
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="upd"
  declare @procclassname tmsobjname
  select  @procclassname="cource"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  update cource
    set 
       currency = @currency,
       rate = @rate
    where id=@id

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "cource", "del", 2
go
create procedure cource$$del
  @id int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @procclassname tmsobjname
  select  @procclassname="cource"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  delete from cource where id=@id
  delete from root where id=@id
return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure cource$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="del"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id    end else begin                                       
      select @errormsg=                             
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

create procedure get_cource
  @a_currency tcurrencyname
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="get_cource"

      select rate from cource$vx
        where currency_name = @a_currency
        and date=(
                  select max(date) from cource$vx
                  where currency_name = @a_currency
                 )
  
return 0
errorex:
  raiserror 50000 @errormsg
go

exec registerclass "event", "root"
go
create table event (
id int not null,
name teventname not null

)
go
create view event$vi as
  select  root.id, class_name=class.name,
          event.name
  from    root, class,
          event
  where   root.class=class.id
    and   event.id=root.id
go

create view event$vxi as
  select  root.id, class_name=class.name,
          event.name
  from    root, class,
          event
  where   root.class=class.id
    and   event.id=root.id
go

create view event$v as
  select  root.id, class_name=class.name,
          event.name
  from    root, class,
          event
  where   root.class=class.id    and   class.name="event"
    and   event.id=root.id
go

create view event$vx as
  select  root.id, class_name=class.name,
          event.name
  from    root, class,
          event
  where   root.class=class.id    and   class.name="event"
    and   event.id=root.id
go

exec registermethod "event", "dup", 2
go
create procedure event$$dup
  @id int,
  @parent int,
  @duplicate int output
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="dup"
  declare @procclassname tmsobjname
  select  @procclassname="event"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  declare @u0000000e int
  select  @u0000000e=@id
  declare @u0000000e$old int
  select  @u0000000e$old=@u0000000e
  select @u0000000e=id    from class where name="event"
  insert into root(class, parent) values(@u0000000e, null)
  select @u0000000e=@@identity
  insert into event (id, name)
    select @u0000000e, name
      from event
      where id=@u0000000e$old
  select @duplicate=@u0000000e

return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure event$dup
  @id int,
  @parent int,
  @duplicate int output

as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$dup" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="dup"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id,
  @parent=@parent ,
  @duplicate=@duplicate  output
    end else begin                                       
      select @errormsg=                             
        "Method dup of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registermethod "event", "ins", 4
go
create procedure event$ins
  @id int output,
  @name teventname
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="ins"
  declare @procclassname tmsobjname
  select  @procclassname="event"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
  declare @class int
  select @class=id from class where name="event"
  insert into root(class, parent) values(@class, null)
  select @id=@@identity
  insert into event (id, name)
    values (@id, @name)

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "event", "upd", 1
go
create procedure event$upd
  @id int,
  @name teventname
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="upd"
  declare @procclassname tmsobjname
  select  @procclassname="event"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  update event
    set 
       name = @name
    where id=@id

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "event", "del", 2
go
create procedure event$$del
  @id int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @procclassname tmsobjname
  select  @procclassname="event"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  delete from event where id=@id
  delete from root where id=@id
return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure event$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="del"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id    end else begin                                       
      select @errormsg=                             
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registerclass "awork", "root"
go
create table awork (
id int not null,
name tworkname not null,
unit int not null,
quantity tamount not null,
cost tmoney not null,
currency int not null,
event int not null

)
go
create index awork$idx_u00000016 on awork(unit)
go
create index awork$idx_u00000017 on awork(currency)
go
create index awork$idx_u00000018 on awork(event)
go
create trigger awork$ti on awork
for insert
as
  declare @errormsg varchar(255)
  -- trigger $diur$u00000013
  if update(unit)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.unit is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.unit
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   
  if update(currency)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.currency is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.currency
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   
  if update(event)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.event is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.event
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   

  -- trigger $assign$u00000012
  declare @u00000011 int
  select  @u00000011=id from class where name="unit"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.unit
      and not exists (                       
        select id from assignable            
          where as_id=@u00000011           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types unit and @errormsg are not compatible"
      goto errorex
    end                                      
  select  @u00000011=id from class where name="currency"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.currency
      and not exists (                       
        select id from assignable            
          where as_id=@u00000011           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types currency and @errormsg are not compatible"
      goto errorex
    end                                      
  select  @u00000011=id from class where name="event"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.event
      and not exists (                       
        select id from assignable            
          where as_id=@u00000011           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types event and @errormsg are not compatible"
      goto errorex
    end                                      

  return
errorex:
  raiserror 50000 @errormsg
go
create trigger awork$tu on awork
for update
as
  declare @errormsg varchar(255)
  -- trigger $diur$u00000013
  if update(unit)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.unit is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.unit
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   
  if update(currency)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.currency is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.currency
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   
  if update(event)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.event is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.event
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   

  -- trigger $assign$u00000012
  declare @u00000011 int
  select  @u00000011=id from class where name="unit"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.unit
      and not exists (                       
        select id from assignable            
          where as_id=@u00000011           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types unit and @errormsg are not compatible"
      goto errorex
    end                                      
  select  @u00000011=id from class where name="currency"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.currency
      and not exists (                       
        select id from assignable            
          where as_id=@u00000011           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types currency and @errormsg are not compatible"
      goto errorex
    end                                      
  select  @u00000011=id from class where name="event"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.event
      and not exists (                       
        select id from assignable            
          where as_id=@u00000011           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types event and @errormsg are not compatible"
      goto errorex
    end                                      

  return
errorex:
  raiserror 50000 @errormsg
go
create view awork$vi as
  select  root.id, class_name=class.name,
          awork.name,
          awork.unit,
          awork.quantity,
          awork.cost,
          awork.currency,
          awork.event
  from    root, class,
          awork
  where   root.class=class.id
    and   awork.id=root.id
go

create view awork$vxi as
  select  root.id, class_name=class.name,
          awork.name,
          awork.unit,
          unit_name=u00000019.name,
          awork.quantity,
          awork.cost,
          awork.currency,
          currency_name=u0000001a.name,
          awork.event,
          event_name=u0000001b.name
  from    root, class,
          awork,
          unit u00000019,
          currency u0000001a,
          event u0000001b
  where   root.class=class.id
    and   awork.id=root.id
    and   u00000019.id=awork.unit
    and   u0000001a.id=awork.currency
    and   u0000001b.id=awork.event
go

create view awork$v as
  select  root.id, class_name=class.name,
          awork.name,
          awork.unit,
          awork.quantity,
          awork.cost,
          awork.currency,
          awork.event
  from    root, class,
          awork
  where   root.class=class.id    and   class.name="awork"
    and   awork.id=root.id
go

create view awork$vx as
  select  root.id, class_name=class.name,
          awork.name,
          awork.unit,
          unit_name=u0000001c.name,
          awork.quantity,
          awork.cost,
          awork.currency,
          currency_name=u0000001d.name,
          awork.event,
          event_name=u0000001e.name
  from    root, class,
          awork,
          unit u0000001c,
          currency u0000001d,
          event u0000001e
  where   root.class=class.id    and   class.name="awork"
    and   awork.id=root.id
    and   u0000001c.id=awork.unit
    and   u0000001d.id=awork.currency
    and   u0000001e.id=awork.event
go

exec registermethod "awork", "dup", 2
go
create procedure awork$$dup
  @id int,
  @parent int,
  @duplicate int output
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="dup"
  declare @procclassname tmsobjname
  select  @procclassname="awork"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  declare @u00000010 int
  select  @u00000010=@id
  declare @u00000010$event     int
  declare @u00000010$event$old int
  select  @u00000010$event$old = 
    event from awork
    where id = @u00000010
  exec root$dup @u00000010$event$old, NULL, @u00000010$event output
  declare @u00000010$old int
  select  @u00000010$old=@u00000010
  select @u00000010=id    from class where name="awork"
  insert into root(class, parent) values(@u00000010, null)
  select @u00000010=@@identity
  insert into awork (id, name, unit, quantity, cost, currency, event)
    select @u00000010, name, unit, quantity, cost, currency, @u00000010$event
      from awork
      where id=@u00000010$old
  declare   @u00000010$id  int
  declare   @u00000010$dup int
  declare   @u00000010$fs  int
  declare   @u00000010$cur varchar(255)
  select    @u00000010$cur=convert(varchar(255),@u00000010$old)
  exec ("declare    u00000010$cur insensitive cursor for select id from resource$vi
    where awork="+@u00000010$cur)
  open       u00000010$cur
  fetch next from u00000010$cur into @u00000010$id
  select @u00000010$fs=@@fetch_status
  while (@u00000010$fs<>-1)
    begin
      if (@u00000010$fs=0)
        exec root$dup @id=@u00000010$id, @parent=null, @duplicate=@u00000010$dup output
      select @u00000010$cur=
        " set awork="+convert(varchar(255),@u00000010)+
        " where id="+convert(varchar(255),@u00000010$dup)
      exec ("update resource"+ @u00000010$cur)
      fetch next from u00000010$cur into @u00000010$id
      select @u00000010$fs=@@fetch_status
    end
  close      u00000010$cur
  deallocate u00000010$cur
  select @duplicate=@u00000010

return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure awork$dup
  @id int,
  @parent int,
  @duplicate int output

as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$dup" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="dup"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id,
  @parent=@parent ,
  @duplicate=@duplicate  output
    end else begin                                       
      select @errormsg=                             
        "Method dup of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registermethod "awork", "ins", 4
go
create procedure awork$ins
  @id int output,
  @name tworkname,
  @unit int,
  @quantity tamount,
  @cost tmoney,
  @currency int,
  @event int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="ins"
  declare @procclassname tmsobjname
  select  @procclassname="awork"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
  declare @class int
  select @class=id from class where name="awork"
  insert into root(class, parent) values(@class, null)
  select @id=@@identity
  insert into awork (id, name, unit, quantity, cost, currency, event)
    values (@id, @name, @unit, @quantity, @cost, @currency, @event)

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "awork", "upd", 1
go
create procedure awork$upd
  @id int,
  @name tworkname,
  @unit int,
  @quantity tamount,
  @cost tmoney,
  @currency int,
  @event int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="upd"
  declare @procclassname tmsobjname
  select  @procclassname="awork"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  update awork
    set 
       name = @name,
       unit = @unit,
       quantity = @quantity,
       cost = @cost,
       currency = @currency,
       event = @event
    where id=@id

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "awork", "del", 2
go
create procedure awork$$del
  @id int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @procclassname tmsobjname
  select  @procclassname="awork"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  delete from awork where id=@id
  delete from root where id=@id
return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure awork$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="del"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id    end else begin                                       
      select @errormsg=                             
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registerclass "resource", "root"
go
create table resource (
id int not null,
awork int not null,
name tresourcename not null,
currency int not null,
cost tmoney not null

)
go
create index resource$idx_u00000025 on resource(awork)
go
create index resource$idx_u00000026 on resource(currency)
go
create trigger resource$ti on resource
for insert
as
  declare @errormsg varchar(255)
  -- trigger $diur$u00000022
  if update(awork)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.awork is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.awork
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   
  if update(currency)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.currency is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.currency
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   

  -- trigger $assign$u00000021
  declare @u00000020 int
  select  @u00000020=id from class where name="awork"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.awork
      and not exists (                       
        select id from assignable            
          where as_id=@u00000020           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types awork and @errormsg are not compatible"
      goto errorex
    end                                      
  select  @u00000020=id from class where name="currency"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.currency
      and not exists (                       
        select id from assignable            
          where as_id=@u00000020           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types currency and @errormsg are not compatible"
      goto errorex
    end                                      

  return
errorex:
  raiserror 50000 @errormsg
go
create trigger resource$tu on resource
for update
as
  declare @errormsg varchar(255)
  -- trigger $diur$u00000022
  if update(awork)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.awork is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.awork
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   
  if update(currency)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.currency is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.currency
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   

  -- trigger $assign$u00000021
  declare @u00000020 int
  select  @u00000020=id from class where name="awork"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.awork
      and not exists (                       
        select id from assignable            
          where as_id=@u00000020           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types awork and @errormsg are not compatible"
      goto errorex
    end                                      
  select  @u00000020=id from class where name="currency"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.currency
      and not exists (                       
        select id from assignable            
          where as_id=@u00000020           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types currency and @errormsg are not compatible"
      goto errorex
    end                                      

  return
errorex:
  raiserror 50000 @errormsg
go
create view resource$vi as
  select  root.id, class_name=class.name,
          resource.awork,
          resource.name,
          resource.currency,
          resource.cost
  from    root, class,
          resource
  where   root.class=class.id
    and   resource.id=root.id
go

create view resource$vxi as
  select  root.id, class_name=class.name,
          resource.awork,
          awork_name=u00000027.name,
          resource.name,
          resource.currency,
          currency_name=u00000028.name,
          resource.cost
  from    root, class,
          resource,
          awork u00000027,
          currency u00000028
  where   root.class=class.id
    and   resource.id=root.id
    and   u00000027.id=resource.awork
    and   u00000028.id=resource.currency
go

create view resource$v as
  select  root.id, class_name=class.name,
          resource.awork,
          resource.name,
          resource.currency,
          resource.cost
  from    root, class,
          resource
  where   root.class=class.id    and   class.name="resource"
    and   resource.id=root.id
go

create view resource$vx as
  select  root.id, class_name=class.name,
          resource.awork,
          awork_name=u00000029.name,
          resource.name,
          resource.currency,
          currency_name=u0000002a.name,
          resource.cost
  from    root, class,
          resource,
          awork u00000029,
          currency u0000002a
  where   root.class=class.id    and   class.name="resource"
    and   resource.id=root.id
    and   u00000029.id=resource.awork
    and   u0000002a.id=resource.currency
go

exec registermethod "resource", "dup", 2
go
create procedure resource$$dup
  @id int,
  @parent int,
  @duplicate int output
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="dup"
  declare @procclassname tmsobjname
  select  @procclassname="resource"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  declare @u0000001f int
  select  @u0000001f=@id
  declare @u0000001f$old int
  select  @u0000001f$old=@u0000001f
  select @u0000001f=id    from class where name="resource"
  insert into root(class, parent) values(@u0000001f, null)
  select @u0000001f=@@identity
  insert into resource (id, awork, name, currency, cost)
    select @u0000001f, awork, name, currency, cost
      from resource
      where id=@u0000001f$old
  select @duplicate=@u0000001f

return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure resource$dup
  @id int,
  @parent int,
  @duplicate int output

as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$dup" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="dup"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id,
  @parent=@parent ,
  @duplicate=@duplicate  output
    end else begin                                       
      select @errormsg=                             
        "Method dup of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registermethod "resource", "ins", 4
go
create procedure resource$ins
  @id int output,
  @awork int,
  @name tresourcename,
  @currency int,
  @cost tmoney
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="ins"
  declare @procclassname tmsobjname
  select  @procclassname="resource"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
  declare @class int
  select @class=id from class where name="resource"
  insert into root(class, parent) values(@class, null)
  select @id=@@identity
  insert into resource (id, awork, name, currency, cost)
    values (@id, @awork, @name, @currency, @cost)

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "resource", "upd", 1
go
create procedure resource$upd
  @id int,
  @awork int,
  @name tresourcename,
  @currency int,
  @cost tmoney
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="upd"
  declare @procclassname tmsobjname
  select  @procclassname="resource"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  update resource
    set 
       awork = @awork,
       name = @name,
       currency = @currency,
       cost = @cost
    where id=@id

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "resource", "del", 2
go
create procedure resource$$del
  @id int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @procclassname tmsobjname
  select  @procclassname="resource"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  delete from resource where id=@id
  delete from root where id=@id
return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure resource$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="del"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id    end else begin                                       
      select @errormsg=                             
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registerclass "matherial", "resource"
go
create table matherial (
id int not null,
unit int not null,
quantity tamount not null

)
go
create index matherial$idx_u00000031 on matherial(unit)
go
create trigger matherial$ti on matherial
for insert
as
  declare @errormsg varchar(255)
  -- trigger $diur$u0000002e
  if update(unit)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.unit is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.unit
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   

  -- trigger $assign$u0000002d
  declare @u0000002c int
  select  @u0000002c=id from class where name="unit"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.unit
      and not exists (                       
        select id from assignable            
          where as_id=@u0000002c           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types unit and @errormsg are not compatible"
      goto errorex
    end                                      

  return
errorex:
  raiserror 50000 @errormsg
go
create trigger matherial$tu on matherial
for update
as
  declare @errormsg varchar(255)
  -- trigger $diur$u0000002e
  if update(unit)           
    begin                                 
      if exists                           
        (                                 
          select * from inserted          
            where inserted.unit is not null
            and not exists                
              (                           
                select * from root        
                  where root.id=inserted.unit
              )                           
        )                                 
        begin                             
          select @errormsg="Can't resolve foregin key"
          goto errorex
        end                               
    end                                   

  -- trigger $assign$u0000002d
  declare @u0000002c int
  select  @u0000002c=id from class where name="unit"
  if exists (                                
    select root.class from root, inserted    
      where root.id=inserted.unit
      and not exists (                       
        select id from assignable            
          where as_id=@u0000002c           
          and id=root.class))                
    begin                                    
      select @errormsg=max(class.name)  
        from class, root, inserted           
        where inserted.id=root.id and root.class=class.id
      select @errormsg="DAR: Types unit and @errormsg are not compatible"
      goto errorex
    end                                      

  return
errorex:
  raiserror 50000 @errormsg
go
create view matherial$vi as
  select  root.id, class_name=class.name,
          resource.awork,
          resource.name,
          resource.currency,
          resource.cost,
          matherial.unit,
          matherial.quantity
  from    root, class,
          resource,
          matherial
  where   root.class=class.id
    and   resource.id=root.id
    and   matherial.id=root.id
go

create view matherial$vxi as
  select  root.id, class_name=class.name,
          resource.awork,
          awork_name=u00000032.name,
          resource.name,
          resource.currency,
          currency_name=u00000033.name,
          resource.cost,
          matherial.unit,
          unit_name=u00000034.name,
          matherial.quantity
  from    root, class,
          resource,
          awork u00000032,
          currency u00000033,
          matherial,
          unit u00000034
  where   root.class=class.id
    and   resource.id=root.id
    and   u00000032.id=resource.awork
    and   u00000033.id=resource.currency
    and   matherial.id=root.id
    and   u00000034.id=matherial.unit
go

create view matherial$v as
  select  root.id, class_name=class.name,
          resource.awork,
          resource.name,
          resource.currency,
          resource.cost,
          matherial.unit,
          matherial.quantity
  from    root, class,
          resource,
          matherial
  where   root.class=class.id    and   class.name="matherial"
    and   resource.id=root.id
    and   matherial.id=root.id
go

create view matherial$vx as
  select  root.id, class_name=class.name,
          resource.awork,
          awork_name=u00000035.name,
          resource.name,
          resource.currency,
          currency_name=u00000036.name,
          resource.cost,
          matherial.unit,
          unit_name=u00000037.name,
          matherial.quantity
  from    root, class,
          resource,
          awork u00000035,
          currency u00000036,
          matherial,
          unit u00000037
  where   root.class=class.id    and   class.name="matherial"
    and   resource.id=root.id
    and   u00000035.id=resource.awork
    and   u00000036.id=resource.currency
    and   matherial.id=root.id
    and   u00000037.id=matherial.unit
go

exec registermethod "matherial", "dup", 2
go
create procedure matherial$$dup
  @id int,
  @parent int,
  @duplicate int output
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="dup"
  declare @procclassname tmsobjname
  select  @procclassname="matherial"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  declare @u0000002b int
  select  @u0000002b=@id
  declare @u0000002b$old int
  select  @u0000002b$old=@u0000002b
  select @u0000002b=id    from class where name="matherial"
  insert into root(class, parent) values(@u0000002b, null)
  select @u0000002b=@@identity
  insert into resource (id, awork, name, currency, cost)
    select @u0000002b, awork, name, currency, cost
      from resource
      where id=@u0000002b$old
  insert into matherial (id, unit, quantity)
    select @u0000002b, unit, quantity
      from matherial
      where id=@u0000002b$old
  select @duplicate=@u0000002b

return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure matherial$dup
  @id int,
  @parent int,
  @duplicate int output

as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$dup" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="dup"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id,
  @parent=@parent ,
  @duplicate=@duplicate  output
    end else begin                                       
      select @errormsg=                             
        "Method dup of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registermethod "matherial", "ins", 4
go
create procedure matherial$ins
  @id int output,
  @awork int,
  @name tresourcename,
  @currency int,
  @cost tmoney,
  @unit int,
  @quantity tamount
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="ins"
  declare @procclassname tmsobjname
  select  @procclassname="matherial"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
  declare @class int
  select @class=id from class where name="matherial"
  insert into root(class, parent) values(@class, null)
  select @id=@@identity
  insert into resource (id, awork, name, currency, cost)
    values (@id, @awork, @name, @currency, @cost)
  insert into matherial (id, unit, quantity)
    values (@id, @unit, @quantity)

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "matherial", "upd", 1
go
create procedure matherial$upd
  @id int,
  @awork int,
  @name tresourcename,
  @currency int,
  @cost tmoney,
  @unit int,
  @quantity tamount
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="upd"
  declare @procclassname tmsobjname
  select  @procclassname="matherial"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  update resource
    set 
       awork = @awork,
       name = @name,
       currency = @currency,
       cost = @cost
    where id=@id
  update matherial
    set 
       unit = @unit,
       quantity = @quantity
    where id=@id

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "matherial", "del", 2
go
create procedure matherial$$del
  @id int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @procclassname tmsobjname
  select  @procclassname="matherial"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  delete from matherial where id=@id
  delete from resource where id=@id
  delete from root where id=@id
return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure matherial$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="del"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id    end else begin                                       
      select @errormsg=                             
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registerclass "executor", "resource"
go
create table executor (
id int not null,
peoplehours tamount not null

)
go
create view executor$vi as
  select  root.id, class_name=class.name,
          resource.awork,
          resource.name,
          resource.currency,
          resource.cost,
          executor.peoplehours
  from    root, class,
          resource,
          executor
  where   root.class=class.id
    and   resource.id=root.id
    and   executor.id=root.id
go

create view executor$vxi as
  select  root.id, class_name=class.name,
          resource.awork,
          awork_name=u0000003a.name,
          resource.name,
          resource.currency,
          currency_name=u0000003b.name,
          resource.cost,
          executor.peoplehours
  from    root, class,
          resource,
          awork u0000003a,
          currency u0000003b,
          executor
  where   root.class=class.id
    and   resource.id=root.id
    and   u0000003a.id=resource.awork
    and   u0000003b.id=resource.currency
    and   executor.id=root.id
go

create view executor$v as
  select  root.id, class_name=class.name,
          resource.awork,
          resource.name,
          resource.currency,
          resource.cost,
          executor.peoplehours
  from    root, class,
          resource,
          executor
  where   root.class=class.id    and   class.name="executor"
    and   resource.id=root.id
    and   executor.id=root.id
go

create view executor$vx as
  select  root.id, class_name=class.name,
          resource.awork,
          awork_name=u0000003c.name,
          resource.name,
          resource.currency,
          currency_name=u0000003d.name,
          resource.cost,
          executor.peoplehours
  from    root, class,
          resource,
          awork u0000003c,
          currency u0000003d,
          executor
  where   root.class=class.id    and   class.name="executor"
    and   resource.id=root.id
    and   u0000003c.id=resource.awork
    and   u0000003d.id=resource.currency
    and   executor.id=root.id
go

exec registermethod "executor", "dup", 2
go
create procedure executor$$dup
  @id int,
  @parent int,
  @duplicate int output
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="dup"
  declare @procclassname tmsobjname
  select  @procclassname="executor"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  declare @u00000038 int
  select  @u00000038=@id
  declare @u00000038$old int
  select  @u00000038$old=@u00000038
  select @u00000038=id    from class where name="executor"
  insert into root(class, parent) values(@u00000038, null)
  select @u00000038=@@identity
  insert into resource (id, awork, name, currency, cost)
    select @u00000038, awork, name, currency, cost
      from resource
      where id=@u00000038$old
  insert into executor (id, peoplehours)
    select @u00000038, peoplehours
      from executor
      where id=@u00000038$old
  select @duplicate=@u00000038

return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure executor$dup
  @id int,
  @parent int,
  @duplicate int output

as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$dup" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="dup"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id,
  @parent=@parent ,
  @duplicate=@duplicate  output
    end else begin                                       
      select @errormsg=                             
        "Method dup of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go

exec registermethod "executor", "ins", 4
go
create procedure executor$ins
  @id int output,
  @awork int,
  @name tresourcename,
  @currency int,
  @cost tmoney,
  @peoplehours tamount
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="ins"
  declare @procclassname tmsobjname
  select  @procclassname="executor"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
  declare @class int
  select @class=id from class where name="executor"
  insert into root(class, parent) values(@class, null)
  select @id=@@identity
  insert into resource (id, awork, name, currency, cost)
    values (@id, @awork, @name, @currency, @cost)
  insert into executor (id, peoplehours)
    values (@id, @peoplehours)

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "executor", "upd", 1
go
create procedure executor$upd
  @id int,
  @awork int,
  @name tresourcename,
  @currency int,
  @cost tmoney,
  @peoplehours tamount
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="upd"
  declare @procclassname tmsobjname
  select  @procclassname="executor"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  update resource
    set 
       awork = @awork,
       name = @name,
       currency = @currency,
       cost = @cost
    where id=@id
  update executor
    set 
       peoplehours = @peoplehours
    where id=@id

return 0
errorex:
  raiserror 50000 @errormsg
go

exec registermethod "executor", "del", 2
go
create procedure executor$$del
  @id int
as
  declare @errormsg varchar(255)
  declare @methodname tmsobjname
  select  @methodname="del"
  declare @procclassname tmsobjname
  select  @procclassname="executor"
  declare @classname tmsobjname
  select  @classname=class.name from class, root
    where root.id=@id and class.id=root.class   
 if not exists (                          
   select assignable.id from assignable, class, root 
     where assignable.id=root.class       
     and assignable.as_id=class.id        
     and class.name=@procclassname        
     and root.id=@id)                     
  begin                                   
      select @errormsg="DMC: Types "+@procclassname+" and "+@classname+" are not compatible"
      goto errorex
  end                                     
  delete from executor where id=@id
  delete from resource where id=@id
  delete from root where id=@id
return 0
errorex:
  raiserror 50000 @errormsg
go

create procedure executor$del
  @id int
as
  declare @errormsg varchar(255)
  declare @proc tmsobjname
  declare @classname tmsobjname
  select @classname=class.name from class, root
    where root.id=@id            
    and class.id=root.class      
  select @proc=class.name+"$$del" from class, method
    where class.name=@classname  
    and method.class=class.id    
    and method.name="del"
  if @proc is not null                     
    begin                                  
  exec @proc
    @id=@id    end else begin                                       
      select @errormsg=                             
        "Method del of "+@classname+" not found!"
      raiserror 50000 @errormsg
    end                                                  

go


create trigger root$tu on root
for update
as
  declare @errormsg varchar(255)
  -- trigger $mur$u0000002f
  if update(id)                          
    begin                                 
      if exists                           
        (                                 
          select * from deleted, matherial
            where deleted.id=matherial.unit
        )                                 
        begin                             
          select @errormsg="Can't update master when detail exists"
          goto errorex
        end                               
    end                                   

  -- trigger $mur$u00000023
  if update(id)                          
    begin                                 
      if exists                           
        (                                 
          select * from deleted, resource
            where deleted.id=resource.awork
        )                                 
        begin                             
          select @errormsg="Can't update master when detail exists"
          goto errorex
        end                               
    end                                   
  if update(id)                          
    begin                                 
      if exists                           
        (                                 
          select * from deleted, resource
            where deleted.id=resource.currency
        )                                 
        begin                             
          select @errormsg="Can't update master when detail exists"
          goto errorex
        end                               
    end                                   

  -- trigger $mur$u00000014
  if update(id)                          
    begin                                 
      if exists                           
        (                                 
          select * from deleted, awork
            where deleted.id=awork.unit
        )                                 
        begin                             
          select @errormsg="Can't update master when detail exists"
          goto errorex
        end                               
    end                                   
  if update(id)                          
    begin                                 
      if exists                           
        (                                 
          select * from deleted, awork
            where deleted.id=awork.currency
        )                                 
        begin                             
          select @errormsg="Can't update master when detail exists"
          goto errorex
        end                               
    end                                   
  if update(id)                          
    begin                                 
      if exists                           
        (                                 
          select * from deleted, awork
            where deleted.id=awork.event
        )                                 
        begin                             
          select @errormsg="Can't update master when detail exists"
          goto errorex
        end                               
    end                                   

  -- trigger $mur$u00000009
  if update(id)                          
    begin                                 
      if exists                           
        (                                 
          select * from deleted, cource
            where deleted.id=cource.currency
        )                                 
        begin                             
          select @errormsg="Can't update master when detail exists"
          goto errorex
        end                               
    end                                   

  return
errorex:
  raiserror 50000 @errormsg
go

create trigger root$td on root
for delete
as
  declare @errormsg varchar(255)
  -- trigger $mdr$u00000030
      if exists                           
        (                                 
          select * from deleted, matherial
            where deleted.id=matherial.unit
        )                                 
        begin                             
          select @errormsg="Can't delete master when detail exists"
          goto errorex
        end                               

  -- trigger $mdr$u00000024
      if exists                           
        (                                 
          select * from deleted, resource
            where deleted.id=resource.awork
        )                                 
        begin                             
          select @errormsg="Can't delete master when detail exists"
          goto errorex
        end                               
      if exists                           
        (                                 
          select * from deleted, resource
            where deleted.id=resource.currency
        )                                 
        begin                             
          select @errormsg="Can't delete master when detail exists"
          goto errorex
        end                               

  -- trigger $mdr$u00000015
      if exists                           
        (                                 
          select * from deleted, awork
            where deleted.id=awork.unit
        )                                 
        begin                             
          select @errormsg="Can't delete master when detail exists"
          goto errorex
        end                               
      if exists                           
        (                                 
          select * from deleted, awork
            where deleted.id=awork.currency
        )                                 
        begin                             
          select @errormsg="Can't delete master when detail exists"
          goto errorex
        end                               
      if exists                           
        (                                 
          select * from deleted, awork
            where deleted.id=awork.event
        )                                 
        begin                             
          select @errormsg="Can't delete master when detail exists"
          goto errorex
        end                               

  -- trigger $mdr$u0000000a
      if exists                           
        (                                 
          select * from deleted, cource
            where deleted.id=cource.currency
        )                                 
        begin                             
          select @errormsg="Can't delete master when detail exists"
          goto errorex
        end                               

  return
errorex:
  raiserror 50000 @errormsg
go

